#property  copyright ""
#property  link      ""

#property  indicator_separate_window
#property  indicator_buffers 6
#property  indicator_color1 DarkGreen
#property  indicator_color2 Maroon
#property  indicator_color3 SeaGreen
#property  indicator_color4 FireBrick
#property  indicator_color5 Lime
#property  indicator_color6 Goldenrod
#property  indicator_width1 6
#property  indicator_width2 6
#property  indicator_width3 2
#property  indicator_width4 2
#property  indicator_width5 1
#property  indicator_width6 1
 
extern int period=34;

double         ExtBuffer0[];
double         ExtBuffer1[];
double         ExtBuffer2[];
double         ExtBuffer3[];
double         ExtBuffer4[];
double         ExtBuffer5[];
double         ExtBuffer6[];
double         Value[];
int barcount;
int temp1,temp2,temp3,temp4;

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,ExtBuffer1);
   SetIndexBuffer(1,ExtBuffer2);
   SetIndexBuffer(2,ExtBuffer3);
   SetIndexBuffer(3,ExtBuffer4);
   SetIndexBuffer(4,ExtBuffer5);
   SetIndexBuffer(5,ExtBuffer6);

   SetIndexBuffer(6,ExtBuffer0);
   SetIndexBuffer(7,Value);

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexStyle(5,DRAW_HISTOGRAM);

   IndicatorShortName("Fisher''s transform");
   IndicatorDigits(Digits+1);

barcount=Bars;
   return(0);
}


int start()
{
   int   limit;
   int   counted_bars=IndicatorCounted();

   if(counted_bars>0)
    {
     limit=-2;
     if(barcount!=Bars)
      {
       counted_bars=0;
       barcount=Bars;
      }
    }
   if(counted_bars==0)limit=Bars-counted_bars;

   for(int i=limit; i>=0; i--)
   {  
      double MaxH  = High[iHighest(NULL,0,MODE_HIGH,period,i)];
      double MinL  = Low [iLowest( NULL,0,MODE_LOW, period,i)];
      double price = (High[i]+Low[i])/2;
      if (MaxH!=MinL)
            Value[i] = 0.33*2*((price-MinL)/(MaxH-MinL)-0.5) + 0.67*Value[i+1];
      else  Value[i] = 0.00;
            Value[i] = MathMin(MathMax(Value[i],-0.999),0.999); 
            ExtBuffer0[i]=1.47*MathLog((1+Value[i])/(1-Value[i]))+0.99*ExtBuffer0[i+1];
      
      if(ExtBuffer0[i]<0)
      {
         ExtBuffer2[i]=ExtBuffer0[i];
         ExtBuffer1[i]=0.0;
      }
      else
      {
         ExtBuffer1[i]=ExtBuffer0[i];
         ExtBuffer2[i]=0.0;
      }
   }

   for(i=limit+1; i>=0; i--)
   {  
      MaxH  = High[iHighest(NULL,0,MODE_HIGH,period,i)];
      MinL  = Low [iLowest( NULL,0,MODE_LOW, period,i)];
      price = (High[i]+Low[i])/2;
      if (MaxH!=MinL)
            Value[i] = 0.33*2*((price-MinL)/(MaxH-MinL)-0.5) + 0.67*Value[i+1];
      else  Value[i] = 0.00;
            Value[i] = MathMin(MathMax(Value[i],-0.999),0.999); 
            ExtBuffer0[i]=1.32*MathLog((1+Value[i])/(1-Value[i]))+0.981*ExtBuffer0[i+1];

      if(ExtBuffer0[i]<0)
      {
         ExtBuffer4[i]=ExtBuffer0[i];
         ExtBuffer3[i]=0.0;
      }
      else
      {
         ExtBuffer3[i]=ExtBuffer0[i];
         ExtBuffer4[i]=0.0;
      }
   }

   for(i=limit+1; i>=0; i--)
   {  
      MaxH  = High[iHighest(NULL,0,MODE_HIGH,period,i)];
      MinL  = Low [iLowest( NULL,0,MODE_LOW, period,i)];
      price = (High[i]+Low[i])/2;
      if (MaxH!=MinL)
            Value[i] = 0.33*2*((price-MinL)/(MaxH-MinL)-0.5) + 0.67*Value[i+1];
      else  Value[i] = 0.00;
            Value[i] = MathMin(MathMax(Value[i],-0.999),0.999); 
            ExtBuffer0[i]=6.66*MathLog((1+Value[i])/(1-Value[i]))+0.5*ExtBuffer0[i+1];

      if(ExtBuffer0[i]<0)
      {
         ExtBuffer6[i]=ExtBuffer0[i];
         ExtBuffer5[i]=0.0;
      }
      else
      {
         ExtBuffer5[i]=ExtBuffer0[i];
         ExtBuffer6[i]=0.0;
      }
   }
   return(0);
}